#include "MatrixColorSensor.h"

bool MatrixColor::begin(uint8_t ver, uint8_t ch){
	_ver = ver;
	_ch = ch;
	i2cMUXSelect();
	if(i2cReadData(MatrixColor_ADDR, MatrixColor_ID) == 0x43){
		i2cWriteData(MatrixColor_ADDR, MatrixColor_ENABLE, 0x0F);
		// i2cWriteData(MatrixColor_ADDR, MatrixColor_LIGHT, 0x0F);
		return true;
	}
	else{
		return false;
	}
	return true;
}

uint8_t MatrixColor::getR(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_RED);
}

uint8_t MatrixColor::getG(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_GREEN);
}

uint8_t MatrixColor::getB(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_BLUE);
}

uint8_t MatrixColor::getC(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_CYAN);
}

uint8_t MatrixColor::getM(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_MAGENTA);
}

uint8_t MatrixColor::getY(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_YELLOW);
}

uint8_t MatrixColor::getK(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_BLACKK);
}

uint8_t MatrixColor::getGrayscale(){
	return i2cReadData(MatrixColor_ADDR, MatrixColor_GRAY);
}

/*
	Number of color as follow as below:
	0:Black
	1:White
	2:Cyan
	3:Ocean
	4:Blue
	5:Violet
	6:Magenta
	7:Raspberry
	8:Red
	9:Orange
	10:Yellow
	11:Spring Green
	12:Green
	13:Turquoise
*/
uint8_t MatrixColor::getColorNumber(){
	i2cMUXSelect();
	return i2cReadData(MatrixColor_ADDR, MatrixColor_NUM_COLOR);
}

uint8_t MatrixColor::i2cReadData(int dev, uint8_t addr){
	
	Wire.beginTransmission(dev);
	Wire.write(addr);
	Wire.endTransmission(1);

	delay(1);

	Wire.requestFrom(dev, 1);

	delay(1);

	return Wire.read();
}

void MatrixColor::i2cMUXSelect(){
	switch (_ver)
	{
	case 2:
		Wire.beginTransmission(ADDR_PCA954X);
		Wire.write(_ch + 4);
		Wire.endTransmission(1);

		delay(10);
		break;
	case 3:
		Wire.beginTransmission(ADDR_PCA954X);
		Wire.write((1 << _ch));
		Wire.endTransmission(1);
		
		delay(10);
		break;
	default:
		break;
	}
}

void MatrixColor::i2cWriteData(uint8_t dev, uint8_t addr, uint8_t data){

	Wire.beginTransmission(dev);

	Wire.write(addr);
	Wire.write(data);

	Wire.endTransmission(1);
}
