#ifndef _MatrixColorSensor_H_
#define _MatrixColorSensor_H_

#include <Arduino.h>
#include <Wire.h>

#define ADDR_PCA954X 0x70

#define MatrixColor_ADDR 		0x22

#define MatrixColor_ID			0x01
#define MatrixColor_ENABLE		0x02
#define MatrixColor_LIGHT		0x03
#define MatrixColor_RED			0x04
#define MatrixColor_GREEN		0x05
#define MatrixColor_BLUE		0x06
#define MatrixColor_CYAN		0x07
#define MatrixColor_MAGENTA		0x08
#define MatrixColor_YELLOW		0x09
#define MatrixColor_BLACKK		0x0A
#define MatrixColor_GRAY		0x0B
#define MatrixColor_NUM_COLOR	0x0C


class MatrixColor{
private:
	uint8_t _ch, _ver;
	uint8_t i2cReadData(int dev, uint8_t addr);
	void i2cMUXSelect();
	void i2cWriteData(uint8_t dev, uint8_t addr, uint8_t data);
public:
	friend class MiniI2C;
	bool begin(uint8_t ver=1, uint8_t ch=0);
	
	uint8_t getR();
	uint8_t getG();
	uint8_t getB();
	
	uint8_t getC();
	uint8_t getM();
	uint8_t getY();
	uint8_t getK();

	uint8_t getGrayscale();

	uint8_t getColorNumber();
};

#endif